#!/bin/sh

MICROCODE_URL="http://people.debian.org/~cate/files/microcode/microcode.dat"
MICROCODE_DIR="http://people.debian.org/~cate/files/microcode/"

if [ ! -x /usr/bin/wget ] ; then
    echo "wget not found. Please install wget"
    exit 1
fi

action="none"
if [ -f /usr/share/misc/microcode.dat ] ; then
    DATE=$(sed -ne 's#^/\*\(.*\)\*/$#\1#p' /usr/share/misc/microcode.dat | head -n 1 | date --rfc-3339=date -f - )
    VERSION=$(wget -t 2 -T 20 -q -O - "${MICROCODE_DIR}latest-${DATE}")
    if [ "x$?" = "x0" ] ; then
	if [ "x$VERSION" = "xold" ] ; then
	    action="download"
	fi
    else
	echo "Could not check the version on server"
	exit 1
    fi
else
    action="download"
fi
if [ "$action" = "download" ]; then
    echo "Trying to download an new version of microcode."
    if [ -x /usr/bin/wget ]; then
        echo "Now attempting to download microcode."
        if [ -x /bin/bzip2 ]; then
	    if wget -t 2 -T 20 -q -O - "$MICROCODE_URL".bz2 | bzip2 -cd > /usr/share/misc/microcode.dat ; then
	        echo "microcode downloaded sucessfully"
	    else
	        echo "microcode not on web server."
	        echo "Install microcode manually. (See /usr/share/doc/microcode.ctl/README.Debian)"
	    fi
        elif [ -x /bin/gzip ]; then
	    if wget -t 2 -T 20 -q -O - "$MICROCODE_URL".gz | gzip -cd > /usr/share/misc/microcode.dat.gz ; then
		echo "microcode downloaded sucessfully"
	    else
	        echo "microcode not on web server."
	        echo "Install microcode manually. (See /usr/share/doc/microcode.ctl/README.Debian)"
	    fi
        else
	    echo "Could not find gzip, need to extract microcode"
	    echo "Install microcode manually. (See /usr/share/doc/microcode.ctl/README.Debian)"
	fi
    else
        echo "wget not found.";
        echo "Install microcode manually. (See /usr/share/doc/microcode.ctl/README.Debian)"
    fi
fi
